'use strict';

exports.__esModule = true;

var _class, _temp2;

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Sortable = (_temp2 = _class = function (_Component) {
  _inherits(Sortable, _Component);

  function Sortable() {
    var _temp, _this, _ret;

    _classCallCheck(this, Sortable);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {}, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Sortable.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    // find default field to sort on
    if (prevState.sortField && nextProps.fields.find(function (field) {
      return field.key === prevState.sortField;
    })) {
      // old selected sortField is still valid, so don't change state
      return null;
    }

    var fieldInfo = nextProps.fields.find(function (field) {
      return field.default;
    });

    if (fieldInfo) {
      return {
        sortField: fieldInfo.key,
        reversed: !!fieldInfo.reversed
      };
    }

    return null;
  };

  Sortable.prototype.setSortField = function setSortField(sortField) {
    if (this.state.sortField === sortField) {
      this.setState({ reversed: !this.state.reversed });
    } else {
      var fields = this.props.fields;


      this.setState({
        sortField: sortField,
        reversed: !!(fields.find(function (field) {
          return field.key === sortField;
        }) || {}).reversed
      });
    }
  };

  Sortable.prototype.render = function render() {
    var _this2 = this;

    var _state = this.state,
        sortField = _state.sortField,
        reversed = _state.reversed;
    var _props = this.props,
        children = _props.children,
        fields = _props.fields,
        data = _props.data,
        defaultSort = _props.defaultSort,
        render = _props.render;

    var _ref = fields.find(function (field) {
      return field.key === sortField;
    }) || {},
        _ref$sort = _ref.sort,
        sort = _ref$sort === undefined ? defaultSort : _ref$sort;

    var sortedData = sort ? [].concat(data).sort(sort(reversed, sortField)) : [].concat(data);
    var renderProps = {
      data: sortedData, reversed: reversed, setSortField: function setSortField(field) {
        return _this2.setSortField(field);
      }, sortField: sortField
    };

    if (render instanceof Function) {
      return render(renderProps);
    }

    if (children instanceof Function) {
      return children(renderProps);
    }

    return null;
  };

  return Sortable;
}(_react.Component), _class.defaultProps = {
  children: null,
  defaultSort: function defaultSort(reverseSort, byField) {
    return function (a, b) {
      return (reverseSort ? -1 : 1) * (a[byField] || '').localeCompare(b[byField] || '');
    };
  },
  fields: [],
  render: null
}, _temp2);
Sortable.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.node]),
  fields: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    default: _propTypes2.default.bool,
    key: _propTypes2.default.string.isRequired,
    reversed: _propTypes2.default.bool,
    sort: _propTypes2.default.func
  })),
  data: _propTypes2.default.arrayOf(_propTypes2.default.any).isRequired,
  defaultSort: _propTypes2.default.func,
  render: _propTypes2.default.func
} : {};
exports.default = Sortable;
module.exports = exports['default'];